<?php

namespace OroB2B\Bundle\TaxBundle\Form\Type;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\OptionsResolver\OptionsResolver;

use Oro\Bundle\FormBundle\Form\Type\OroEntitySelectOrCreateInlineType;

class TaxJurisdictionSelectType extends AbstractType
{
    const NAME = 'orob2b_tax_jurisdiction_select';

    /**
     * {@inheritdoc}
     */
    public function configureOptions(OptionsResolver $resolver)
    {
        $resolver->setDefaults(
            [
                'autocomplete_alias' => 'orob2b_tax_jurisdiction_autocomplete',
                'create_form_route' => 'orob2b_tax_jurisdiction_create',
                'grid_name' => 'tax-jurisdiction-select-grid',
                'configs' => [
                    'placeholder' => 'orob2b.tax.taxjurisdiction.form.choose',
                ],
            ]
        );
    }

    /**
     * {@inheritdoc}
     */
    public function getName()
    {
        return self::NAME;
    }

    /**
     * {@inheritdoc}
     */
    public function getParent()
    {
        return OroEntitySelectOrCreateInlineType::NAME;
    }
}
